Drupal.behaviors.reference_entity_modal = {
  attach: function (context, settings) {

    jQuery('.referenced-entity-modal-input').each(function(){
      var value = jQuery(this).val();
      jQuery(this).val(removeId(value));
      disableAddButtons(jQuery(this));
    });

    jQuery(document).on('change' , ".referenced-entity-modal-input",function(){
      if(jQuery(this).attr('_validated') == '_validated'){
        jQuery(this).removeAttr('_validated');
      }
      else{
        var target = jQuery(this).closest('.referenced-entity-modal-container').find('.referenced-entity-modal-target');
        target.val(jQuery(this).val());
      }
    });

    jQuery(document).on('keyup' , ".referenced-entity-modal-input",function(){
      enableAddButtons(jQuery(this));
    });
    jQuery(document).on('autocompleteselect' , ".referenced-entity-modal-input",function(){
      disableAddButtons(jQuery(this));
    });

    jQuery('.referenced-entity-modal-input').once().on("autocompleteselect", function( event, ui ) {
        var target = jQuery(this).closest('.referenced-entity-modal-container').find('.referenced-entity-modal-target');
        var uniqueSelector = jQuery(this).attr("name");
        target.val(ui.item.value);
        localStorage.setItem(uniqueSelector, ui.item.value);
        ui.item.value = removeId(ui.item.value);
        jQuery('.referenced-entity-modal-input').focusout(function(){
          target.val(localStorage.getItem(uniqueSelector));
        })
        jQuery(this).attr('_validated','_validated');
        disableAddButtons(jQuery(this));
    });

    function removeId(input){
      var index = input.lastIndexOf('(');
      var last = input.lastIndexOf(')');
      var target = input.substr(index,last - index + 1);
      var splitted = input.split(" " + target);
      if(target.length != 0 && parseInt(target.substr(1,target.length - 2))){
        var joined = splitted.join("");
        if(splitted[splitted.length -1] == '"' && splitted[0].substr(0,1) == '"'){
          var joined = splitted[0].substr(1);
        }
        return joined;
      }
      else{
        return input;
      }
    }

    function disableAddButtons(element){
      if(element.val() == ""){
        element.closest('.referenced-entity-modal-container').removeClass("value-set");
        element.closest('.referenced-entity-modal-container').find('.register-new-school').show();
      }
      else{
        element.closest('.referenced-entity-modal-container').addClass("value-set");
        element.closest('.referenced-entity-modal-container').find('.register-new-school').hide();
      }
    }
    function enableAddButtons(element){
      if(element.val() == ""){
        element.closest('.referenced-entity-modal-container').removeClass("value-set");
        element.closest('.referenced-entity-modal-container').find('.register-new-school').show();
      }
    }

    jQuery('.referenced-entity-modal-container .field-modal-reset').click(function() {
      jQuery(this).parent().find('.referenced-entity-modal-input').val('');
      jQuery(this).parent().find('.referenced-entity-modal-input').trigger('change');
      jQuery(this).closest('.referenced-entity-modal-container').find('.register-new-school').show();
      jQuery(this).closest('.referenced-entity-modal-container').removeClass("value-set");
    });

    jQuery.fn.injectEntity = function(data) {
      data = JSON.parse(data);
      jQuery('.close-entity-modal').click();
      jQuery('.referenced-entity-modal-container').addClass("value-set");
      jQuery('.register-new-school').hide();
      var inputSelector = '[_modal_selector=' + data['selector'] + "-mask-input"+ ']';
      var targetSelector = '[_modal_selector=' + data['selector'] + "-target-id"+ ']';
      jQuery(targetSelector).val(data['entity']);
      jQuery( inputSelector ).val(removeId(data['entity']));
      jQuery([document.documentElement, document.body]).animate({
        scrollTop: jQuery(".referenced-entity-modal-input").offset().top
      });
    };
  }
}



